# MySQL Rat microservice

[![ms-rat](https://git.miem.hse.ru/dmvanin/ms-rat/-/raw/master/ms-rat.jpg)](https://git.miem.hse.ru/dmvanin/ms-rat)  

| Переменные среды | Назначение                                     |
|------------------|------------------------------------------------|
| DB_USER          | Имя пользователя                               |
| DB_PASSWORD      | Пароль для входа в MySQL                       |
| DB_NAME          | Наименование базы данных                       |
| DB_HOST          | Адрес базы данных                              |
| DB_PORT          | Порт базы данных                               |

## Пример docker-compose
```
version: '3'
services:
  db:
    image: mariadb
    restart: always
    environment:
      - MYSQL_ROOT_PASSWORD=P@ssw0rd
      - MYSQL_PASSWORD=P@ssw0rd
      - MYSQL_DATABASE=rat
      - MYSQL_USER=rat
  ms-rat:
    image: ms-rat
    restart: always
    ports:
      - 8080:8080
    environment:
      - DB_USER=rat
      - DB_PASSWORD=P@ssw0rd
      - DB_NAME=rat
      - DB_HOST=db
      - DB_PORT=3306
```

## Использование
### Без docker
`go mod download && go mod verify`

`go build -o ms-rat`
### С docker
`git clone https://git.miem.hse.ru/dmvanin/ms-rat.git`

`cd ms-rat`

`docker build -t ms-rat .`

`docker-compose up -d`
