package main

import (
	"fmt"
	"io"
	"log"
	"os"
	"net/http"
	"database/sql"
	_ "github.com/go-sql-driver/mysql"
)

type Info struct {
	Id int
	Information string
}

func getInfo(w http.ResponseWriter, r *http.Request) {
	db, err := sql.Open("mysql", os.Getenv("DB_USER")  + ":" + os.Getenv("DB_PASSWORD") + "@tcp(" + os.Getenv("DB_HOST") + ":" + os.Getenv("DB_PORT") + ")/" + os.Getenv("DB_NAME"))
	defer db.Close()

	if err != nil {
		log.Fatal(err)
	}

	res, err := db.Query("SELECT * FROM Den")
	defer res.Close()

	if err != nil {
		log.Fatal(err)
	}
	
	for res.Next() {
        var ratinfo Info
        err = res.Scan(&ratinfo.Id, &ratinfo.Information)

        if err != nil {
            log.Fatal(err)
        }

		io.WriteString(w, ratinfo.Information + "\n")
    }

}

func writeInfo(w http.ResponseWriter, r *http.Request) {
	strings, ok := r.URL.Query()["string"]
    
    if !ok || len(strings[0]) < 1 {
        log.Fatal("Url Param 'string' is missing")
        return
    }
	
    str := strings[0]

	db, err := sql.Open("mysql", os.Getenv("DB_USER")  + ":" + os.Getenv("DB_PASSWORD") + "@tcp(" + os.Getenv("DB_HOST") + ":" + os.Getenv("DB_PORT") + ")/" + os.Getenv("DB_NAME"))
	defer db.Close()

	if err != nil {
		log.Fatal(err)
	}

	sql := "INSERT INTO Den(Information) VALUES ('" + string(str) + "')"
    _, err = db.Exec(sql)

    if err != nil {
        panic(err.Error())
    }

	io.WriteString(w, "Written\n")
}

func whoami(w http.ResponseWriter, r *http.Request) {
	io.WriteString(w, "I'm the giant rat that makes all of the rules")
}

func main() {
	db, err := sql.Open("mysql", os.Getenv("DB_USER")  + ":" + os.Getenv("DB_PASSWORD") + "@tcp(" + os.Getenv("DB_HOST") + ":" + os.Getenv("DB_PORT") + ")/" + os.Getenv("DB_NAME"))
	defer db.Close()

	if err != nil {
		log.Fatal(err)
	}

	sql := "CREATE TABLE IF NOT EXISTS Den(Id INT AUTO_INCREMENT PRIMARY KEY, Information VARCHAR(255) NOT NULL) ENGINE=INNODB;"
	_, err = db.Exec(sql)
	if err != nil {
		log.Fatal(err)
	}

	http.HandleFunc("/", getInfo)
	http.HandleFunc("/write", writeInfo)
	http.HandleFunc("/whoami", whoami)
	fmt.Printf("Try to start on port 8080")
	if err := http.ListenAndServe(":8080", nil); err != nil {
		fmt.Printf("An error: %s", err)
	}
}
